const system = require("../../../system");
const ServiceBase = require("../../sve.base");
class PolicyinfoService extends ServiceBase {
  constructor() {
    super("dbpolicy", ServiceBase.getDaoName(PolicyinfoService));
  }

  //政策检索
  async policyQuery(pobj){
    var obj = pobj.actionBody;
    var app = pobj.appInfo;
    var paramObj={uapp_id:app.uapp_id};                                                     
    var attributes =["id","policyType","policyTypeName","policyDate","policyContent","policyCity","policyProvince",
    "policyLinkUrl","policySource","policyName","policyNo"];
    if(obj){
      if(obj.policyProvince){
        paramObj["policyProvince"]=obj.policyProvince;
        if(obj.policyCity){
          paramObj["policyCity"]=obj.policyCity;
        }
      }
      if(obj.policyName){
        paramObj["policyName"]={ [this.db.Op.like]: "%" + obj.policyName + "%" };
      }
      console.log(paramObj);
    }
    var result = {};
    //"policy_type":{'fzbt':'租金减免','jrdk':'金融贷款','zdfc':'扶持措施','ssjm':'税收优惠','rlzy':'人力资源'},
    result["rlzy"]=await this.findByParams("rlzy",paramObj,attributes);
    result["fzbt"]=await this.findByParams("fzbt",paramObj,attributes);
    result["jrdk"]=await this.findByParams("jrdk",paramObj,attributes);
    result["zdfc"]=await this.findByParams("zdfc",paramObj,attributes);
    result["ssjm"]=await this.findByParams("ssjm",paramObj,attributes);
    return  system.getResultSuccess(result);
  }

  async findByParams(type,paramObj,attributes){
    paramObj.policyType=type;
    return await this.dao.model.findAll({
      where:paramObj,raw:true,attributes:attributes
    });
  }
}
module.exports = PolicyinfoService;
